'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var this_directory = __dirname;

var registry = {};

var IoC = function () {
	function IoC() {
		_classCallCheck(this, IoC);

		this.implementations = {};
		this.root_path = '';
	}

	_createClass(IoC, [{
		key: 'root',
		value: function root(root_path) {
			if (root_path.substr(-1) != '/') root_path += '/';

			this.root_path = root_path;
			return this;
		}
	}, {
		key: 'bind',
		value: function bind(path, concrete) {
			path = this.path(path);
			concrete = this.path(concrete);

			this.implementations[path] = concrete;

			return this;
		}
	}, {
		key: 'path',
		value: function path(_path) {
			if (_path.substr(0, 2) == './') {
				_path = this.root_path + _path.substr(2);
			}

			return this.implementations[_path] ? this.implementations[_path] : _path;
		}
	}, {
		key: 'make',
		value: function make(path) {
			if (registry[path]) {
				return registry[path];
			}

			var full_path = this.path(path);

			return require(full_path);
		}
	}, {
		key: 'create',
		value: function create(path) {
			var IoC = this,
			    resolved_path = this.path(path),
			    class_name = this.getClassName(resolved_path),
			    imported = this.make(path)[class_name],
			    args = [];

			var implementation = this.make(path)[class_name] || this.make(path);

			if (implementation.inject) {
				implementation.inject.forEach(function (to_inject) {
					args.push(IoC.create(to_inject));
				});
			}

			var instance = undefined;

			if (implementation.prototype && implementation.prototype.constructor) {
				instance = new (Function.prototype.bind.apply(implementation, [null].concat(args)))();
			} else {
				instance = implementation;

				registry[path] = instance;
			}

			if (implementation.singleton) {
				registry[path] = instance;
			}

			return instance;
		}
	}, {
		key: 'getClassName',
		value: function getClassName(path) {
			var parts = path.split('/');

			return parts[parts.length - 1];
		}
	}]);

	return IoC;
}();

var container = new IoC();

exports.default = container;