'use strict';

require('./auto_mock_off');

var _IoC = require('../IoC');

var _IoC2 = _interopRequireDefault(_IoC);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_IoC2.default.root(__dirname + '/../../');

describe('IoC Container', function () {

	it('should resolve class', function () {
		var service = _IoC2.default.create('./examples/GreetingService');
		var output = service.greet('Adam');
		var expected = 'Greetings, Adam from HelloService';

		expect(output).toBe(expected);
	});

	it('should resolve to mock class', function () {
		_IoC2.default.bind('./examples/HelloService', './examples/MockHelloService');

		var service = _IoC2.default.create('./examples/GreetingService');
		var output = service.greet('Adam');
		var expected = 'Greetings, Adam from MockHelloService';

		expect(output).toBe(expected);
	});

	it('should return singleton', function () {
		var singleton = _IoC2.default.create('./examples/Singleton');
		var second = _IoC2.default.create('./examples/Singleton');
		var third = _IoC2.default.create('./examples/Singleton');

		expect(singleton).toBe(second);
		expect(singleton).toBe(third);
	});
});